% import the data 

clearvars 

[filename_1, path_1] = uigetfile({'*.csv';'*.xls'},'Select One or More Files',"C:\Users\320033994\OneDrive - Philips\Charge retention\V clamp\test_capacitors\", "multiselect",'on');


% divide the files by category and do the average if there is more than one
% file per type

%find regular expression in filename

filename_1 = filename_1';

name_loopnr = zeros(size(filename_1,1),2);
for i = 1:size(filename_1,1)
    name_loopnr(i,1) = str2double(filename_1{i}(2:4));
    name_loopnr(i,2) = str2double(filename_1{i}(end-4));

end

[unique_wafer, ~, idx_unique_wafer] = unique(name_loopnr(:,1));

figure;
data_summary = zeros(length(unique_wafer),2);
for j= 1:size(unique_wafer)

    % gather the files that are from that wafer and do the average 

    filenames_wafer = filename_1(idx_unique_wafer == j);

    % do the average of the meaurements

    min_size = zeros(1,size(filenames_wafer,1));

    for k = 1:size(filenames_wafer,1)
        % do the average of the files 
        V_clamp_values = importVclamp(strcat(path_1, filenames_wafer{k}));
        min_size(k) = height(V_clamp_values);
    end

    min_size = min(min_size);

    I_charge = 0;
    Q_tot = zeros(1,size(filenames_wafer,1));
%     figure;
    for k = 1:size(filenames_wafer,1)
        V_clamp_values = importVclamp(strcat(path_1, filenames_wafer{k}));
%         semilogy(V_clamp_values.delta_time,abs(V_clamp_values.I))
%         hold on
        I_charge = I_charge + [V_clamp_values.I(1:min_size), V_clamp_values.delta_time(1:min_size)];
        Q_tot(k) = trapz(V_clamp_values.delta_time,V_clamp_values.I-100e-15);
    end

    I_charge = I_charge/k;
    semilogy(I_charge(:,2),abs(I_charge(:,1)),'DisplayName',num2str(unique_wafer(j)))
    hold on
    xlabel('Time [s]')
    ylabel('I [A]')
%     title(num2str(unique_wafer(j)))
    Q_tot_mean = mean(Q_tot);

    data_summary(j,:) = [unique_wafer(j),Q_tot_mean];

end

data_summary = array2table(data_summary,"VariableNames",{'wafer','Q_stored'});