% import the data 

clearvars 

[filename_1, path_1] = uigetfile({'*.csv';'*.xls'},'Select One or More Files',"C:\Users\320033994\OneDrive - Philips\Charge retention\V clamp\test_capacitors\", "multiselect",'on');


% divide the files by category and do the average if there is more than one
% file per type

%find regular expression in filename

filename_1 = filename_1';

name_loopnr = zeros(size(filename_1,1),2);
for i = 1:size(filename_1,1)
    name_loopnr(i,1) = str2double(filename_1{i}(2:4));
    name_loopnr(i,2) = str2double(filename_1{i}(end-16));

end

[unique_wafer, ~, idx_unique_wafer] = unique(name_loopnr(:,1));

data_summary = zeros(length(unique_wafer),3);
for j= 1:size(unique_wafer)

    % gather the files that are from that wafer and do the average 

    filenames_wafer = filename_1(idx_unique_wafer == j);

    % do the average of the meaurements

    max_size = zeros(1,size(filenames_wafer,1));

    for k = 1:size(filenames_wafer,1)
        % do the average of the files 
        V_clamp_values = importVclamp(strcat(path_1, filenames_wafer{k}));
        max_size(k) = height(V_clamp_values);
    end

    max_size = max(max_size);

    I_discharge = NaN(max_size,2);
    data = 0;
    Q_tot = zeros(1,size(filenames_wafer,1));
    time_to_discharge = zeros(1,size(filenames_wafer,1));
%     figure;
    for k = 1:size(filenames_wafer,1)
        V_clamp_values = importVclamp(strcat(path_1, filenames_wafer{k}));
%         semilogy(V_clamp_values.delta_time,abs(V_clamp_values.I))
%         hold on
%         I_discharge(1:height(V_clamp_values),:) = [V_clamp_values.I, V_clamp_values.delta_time];
%         data = data + I_discharge;
%         Q_tot(k) = trapz(V_clamp_values.delta_time,V_clamp_values.I);
%         time_to_discharge(k) = V_clamp_values.delta_time(end);

        
%         V_clamp_values.I = V_clamp_values.I + 200e-15;
        I_discharge = ([abs(V_clamp_values.I) - 200e-15, V_clamp_values.delta_time]);
        [~,max_idx] = max(I_discharge(:,1));
        I_discharge = I_discharge(max_idx:end,:);
        a_guess = I_discharge(1,1);
        b_guess = -(I_discharge(2,1)-I_discharge(1,1))/(I_discharge(2,2)-I_discharge(1,2))/...
            (I_discharge(1,1)-I_discharge(end,1));
%         b_guess = 7;
        c_guess = 0.4;
        initial_guess = [a_guess, 1/b_guess, c_guess];
        
        
%         fun = @(params) sqrt(mean((params(1)*exp(-params(2)/I_discharge(:,2)) - I_discharge(:,1)).^2));


        fun = @(params) objective_function_discharge(params,I_discharge); % define the objective function
        options = optimset('MaxIter', 1e4, 'MaxFunEvals', 1e4, 'TolFun', 1e-25, 'TolX', 1e-25);
        result = fminsearch(fun, initial_guess,options);
%         yfitted = result(1) .* exp(-(I_discharge(:,2)./result(2)).^result(3));
        yfitted = 8.28e-12 .* exp(-(I_discharge(:,2)./10).^0.6);

        figure;
        semilogy(I_discharge(:,2),I_discharge(:,1))
        hold on
        semilogy(I_discharge(:,2),yfitted,'--')
        result(1) = result(1)*1e12;
        disp(result)

%         g = fittype('a*exp(-(x/b)^c)');
%         f0 = fit(I_discharge(:,2),I_discharge(:,1),g,'StartPoint',initial_guess, ...
%             'TolFun',1e-30,'MaxIter',1e4,'MaxFunEvals',1e4,'TolX', 1e-20)
%         figure;
%         plot(f0,I_discharge(:,2),I_discharge(:,1),'--')
   

    end

%     data = data/k;
%     semilogy(data(:,2),abs(data(:,1)),'DisplayName',num2str(unique_wafer(j)))
%     hold on
%     xlabel('Time [s]')
%     ylabel('I [A]')
% %     title(num2str(unique_wafer(j)))
%     Q_tot_mean = mean(Q_tot);
%     time_to_discharge_mean = mean(time_to_discharge);
% 
%     data_summary(j,:) = [unique_wafer(j),Q_tot_mean,time_to_discharge_mean];


end

% data_summary = array2table(data_summary,"VariableNames",{'wafer','Q_stored','time_discharge'});