% function Z = equivalent_model(param, f)
function tf_equiv = equivalent_model(params)
% param is an array containing the values of the parameters of the model
% param = [Rm, Cm, Lm, Ce, Rs]

%     w = 2*pi*f;
%     ZCm = -1j./(w * param(2));
%     ZCe = -1j./(w * param(4));
%     ZLm = 1j .* w .* param(3);
%     Zseries = param(1) + ZCm + ZLm;
%     Zequiv = (1./Zseries + 1./ZCe).^-1 + param(5);
% 
%     Zreal = real(Zequiv);
%     Zimag = imag(Zequiv);
%     Z = reshape([Zreal; Zimag], 1, []);

    
    Rm = params(1);
    Cm = params(2);
    Lm = params(3);
    Ce = params(4);
    Rs = params(5);

    tf_Rs = tf(Rs,1);
    tf_CMUT = tf([1, Rm/Lm, 1/(Lm*Cm)], ...
        [Ce, Ce*Rm/Lm, Ce*(Cm+Ce)/(Ce*Cm*Lm), 0]);

    tf_equiv = tf_CMUT + tf_Rs;

end


