function error = objective_function_BVD_model(params, experimental_data)

    [mag,phase,~] = bode(equivalent_model(params),experimental_data.freq*2*pi);
    mag = squeeze(mag);
    phase = squeeze(phase);
    residual_mod = mag - experimental_data.Z;
    residual_phase = phase - experimental_data.Ph;

    % calculate the residual also for real and imaginary part
    [real, imag] = pol2cart(deg2rad(phase),mag);
    [real_exp, imag_exp] = pol2cart(deg2rad(experimental_data.Ph),experimental_data.Z);
    residual_real = real - real_exp;
    residual_imag = imag - imag_exp;

%     error = sum(residual_mod.^2) + sum(residual_phase.^2);
    error = sqrt(mean(residual_mod.^2)) + sqrt(mean(residual_phase.^2)) +...
        sqrt(mean(residual_real.^2)) + sqrt(mean(residual_imag.^2));
end




