%% import and plot IV smu Keithley 237

[filename_1, path_1] = uigetfile({'*.csv';'*.xls'},'Select One or More Files',"C:\Users\320033994\OneDrive - Philips\Charge retention\I-V_curves\", "multiselect",'on');

deff = 400 * 1e-7; % effective thickness of dielectric in cm
area = (300 *1e-4)^2; % area of capacitor in cm^2

figure
t = tiledlayout(1,1);
ax1 = axes(t);
for k = 1:length(filename_1)
    IV = importIV_K237(strcat(path_1, filename_1{k}));
    
    semilogy(ax1,IV.E, abs(IV.J),'DisplayName',filename_1{k},'linewidth',1.5)
%     semilogy(ax1,IV.V*1e-6/deff, abs(IV.I/area),'DisplayName',filename_1{k},'linewidth',1.5)

%     semilogy(ax1,IV.V, abs(IV.I),'DisplayName',filename_1{k},'linewidth',1.5)
    hold on

end
grid on
legend('interpreter','none','location','bestoutside')
% get(gca, xlim)
% xlim([-20 20])
ylim([1e-11 10])
xlabel('E [MV/cm]')
ylabel('J [A/cm^{2}]')

% ax2 = axes(t);
% ax2.XAxisLocation = 'top';
% ax2.YAxisLocation = 'right';
% ax2.YScale = 'log';
% ax2.Color = 'none';
% ax1.Box = 'off';
% ax2.Box = 'off';
% % ax2.YAxis.Visible = 'off'; 
% xlim([-15*deff*1e6 15*deff*1e6])
% ylim([1e-12*area 10*area])
xlabel('Voltage [V]')
ylabel('Current [A]')
% 
% 

% %% this figure plots the Fowler Nordheim plot
% figure
% t = tiledlayout(1,1);
% ax1 = axes(t);
% for k = 1:length(filename_1)
%     IV = importIV_K237(strcat(path_1, filename_1{k}));
%     selection = 1:length(IV.E);
% %     selection = find(abs(IV.E) > 2 & abs(IV.E) < 8.5);
% 
%     y_ax = log(abs(IV.J(selection))./((IV.E(selection)).^2));
%     x_ax = 1./abs(IV.E(selection));
%     plot(ax1,x_ax, y_ax,'.','DisplayName',filename_1{k},'linewidth',1.5)
%     hold on
% 
% end
% grid on
% legend('interpreter','none','location','bestoutside')
% xlabel('1/E [cm/MV]')
% ylabel('log(J/E^2 [A/MV^2])')
% % ylim([-25 -7])
% xl = xlim;
% 
% ax2 = axes(t);
% ax2.XAxisLocation = 'top';
% ax2.YAxisLocation = 'right';
% ax2.YScale = 'log';
% ax2.Color = 'none';
% ax1.Box = 'off';
% ax2.Box = 'off';
% ax2.YAxis.Visible = 'off'; 
% xlim([abs(IV.E(selection(1))) abs(IV.E(selection(end)))])
% set(gca, 'XDir','reverse')
% xlabel('E [MV/cm]')
% ylabel('J [A/cm^2]')
% 
% %% this figure plots the Frenkel-Poole plot
% figure
% t = tiledlayout(1,1);
% ax1 = axes(t);
% for k = 1:length(filename_1)
%     IV = importIV_K237(strcat(path_1, filename_1{k}));
%     selection = 1:length(IV.E);
% %     selection = find(abs(IV.E) > 4 & abs(IV.E) < 9.5);
% 
%     y_ax = log(IV.J(selection)./IV.E(selection));
%     x_ax = sqrt(abs(IV.E(selection)));
%     plot(ax1,x_ax, y_ax,'DisplayName',filename_1{k},'linewidth',1.5)
%     hold on
% 
% end
% grid on
% legend('interpreter','none','location','bestoutside')
% xlabel('E^{1/2} [(MV/cm)^{1/2}]')
% ylabel('log(J/E [A/MV cm])')
% % ylim([-25 -5])
% 
% ax2 = axes(t);
% ax2.XAxisLocation = 'top';
% ax2.YAxisLocation = 'right';
% ax2.YScale = 'log';
% ax2.Color = 'none';
% ax1.Box = 'off';
% ax2.Box = 'off';
% ax2.YAxis.Visible = 'off'; 
% xlim([abs(IV.E(selection(1))) abs(IV.E(selection(end)))])
% xlabel('E [MV/cm]')
% 
% %% this figure plots the Trap Assisted Tunneling plot
% figure
% t = tiledlayout(1,1);
% ax1 = axes(t);
% for k = 1:length(filename_1)
%     IV = importIV_K237(strcat(path_1, filename_1{k}));
% %     selection = 1:length(IV.E);
%     selection = find(abs(IV.E) > 4 & abs(IV.E) < 9.5);
% 
%     y_ax = log(abs(IV.J(selection)));
%     x_ax = 1./abs(IV.E(selection));
%     plot(ax1,x_ax, y_ax,'.','DisplayName',filename_1{k},'linewidth',1.5)
%     hold on
% 
% end
% grid on
% legend('interpreter','none','location','bestoutside')
% xlabel('1/E [cm/MV]')
% ylabel('log(J [A/cm^2])')
% % ylim([-25 -7])
% % xl = xlim;
% 
% ax2 = axes(t);
% ax2.XAxisLocation = 'top';
% ax2.YAxisLocation = 'right';
% ax2.YScale = 'log';
% ax2.Color = 'none';
% ax1.Box = 'off';
% ax2.Box = 'off';
% ax2.YAxis.Visible = 'off'; 
% xlim([abs(IV.E(selection(1))) abs(IV.E(selection(end)))])
% set(gca, 'XDir','reverse')
% xlabel('E [MV/cm]')
% ylabel('J [A/cm^2]')
% 
